import {ENTITY,ENTITY_COLUMN,REF_TYPE,PROCESS_TYPE} from "./const"
import EleRef from "./EleRef"
import InputEleRef from "./InputEleRef"
let columnDefination={}
export function createColumnObject(propertyKey){
    if(!columnDefination[propertyKey]){
        columnDefination[propertyKey]={}
    }
}

export let Column=(type)=>(target,propertyKey)=>{
    createColumnObject(propertyKey)
    columnDefination[propertyKey][ENTITY_COLUMN.TYPE]=type;
    // columnDefination[propertyKey][ENTITY_COLUMN.MAXLENGTH]=maxLength;
}

export let onChange=()=>(target,propertyKey)=>{
    createColumnObject(propertyKey)
    columnDefination[propertyKey][PROCESS_TYPE.ONCHANGE]=true;
    // columnDefination[propertyKey][ENTITY_COLUMN.MAXLENGTH]=maxLength;
}

export let onSubmit=()=>(target,propertyKey)=>{
    createColumnObject(propertyKey)
    columnDefination[propertyKey][PROCESS_TYPE.ONSUBMIT]=true;
    // columnDefination[propertyKey][ENTITY_COLUMN.MAXLENGTH]=maxLength;
}

export let onBlur=()=>(target,propertyKey)=>{
    createColumnObject(propertyKey)
    columnDefination[propertyKey][PROCESS_TYPE.ONBLUR]=true;
    // columnDefination[propertyKey][ENTITY_COLUMN.MAXLENGTH]=maxLength;
}
export let onFocus=()=>(target,propertyKey)=>{
    createColumnObject(propertyKey)
    columnDefination[propertyKey][PROCESS_TYPE.ONFOCUS]=true;
    // columnDefination[propertyKey][ENTITY_COLUMN.MAXLENGTH]=maxLength;
}

export let onKeyUp=()=>(target,propertyKey)=>{
    createColumnObject(propertyKey)
    columnDefination[propertyKey][PROCESS_TYPE.ONKEYUP]=true;
    // columnDefination[propertyKey][ENTITY_COLUMN.MAXLENGTH]=maxLength;
}

export let Validation=(cb:Function)=>(target,propertyKey)=>{
    createColumnObject(propertyKey)
    columnDefination[propertyKey][ENTITY_COLUMN.VALIDATION]=cb;
}

export let Parse=(cb:Function)=>(target,propertyKey)=>{
    //console.log("parse=>",target)
   // target.prototype.parse=cb;
    createColumnObject(propertyKey)
    columnDefination[propertyKey][ENTITY_COLUMN.PARSE]=cb;
}


export let Default=(value:string|number|Date)=>(target,propertyKey)=>{
    createColumnObject(propertyKey)
    columnDefination[propertyKey][ENTITY_COLUMN.DEFAULT]=value;
}

export let StoreEntity=(target:Function)=>{
    for(let key in columnDefination){
        let el;
        if(columnDefination[key][ENTITY_COLUMN.TYPE]==REF_TYPE.INPUT || columnDefination[key][ENTITY_COLUMN.TYPE]==REF_TYPE.HIDDEN){
                el=new InputEleRef();
                if(columnDefination[key][PROCESS_TYPE.ONBLUR]){
                    el.eventObject.blur=true;
                }
                if(columnDefination[key][PROCESS_TYPE.ONCHANGE]){
                    el.eventObject.change=true;
                }
                if(columnDefination[key][PROCESS_TYPE.ONFOCUS]){
                   el.eventObject.focus=true
                }
                if(columnDefination[key][PROCESS_TYPE.ONSUBMIT]){
                    el.eventObject.submit=true
                }
                if(columnDefination[key][PROCESS_TYPE.ONKEYUP]){
                    el.eventObject.keyUp=true
                }
                if(columnDefination[key][ENTITY_COLUMN.PARSE]){
                    el.parse=columnDefination[key][ENTITY_COLUMN.PARSE];
                //target.prototype[key][ENTITY_COLUMN.PARSE]=columnDefination[key][ENTITY_COLUMN.PARSE];
                }
                if(columnDefination[key][ENTITY_COLUMN.VALIDATION]){
                    el.validation=columnDefination[key][ENTITY_COLUMN.VALIDATION];
                //target[key][ENTITY_COLUMN.VALIDATION]=columnDefination[key][ENTITY_COLUMN.VALIDATION];
                }
                if(columnDefination[key][ENTITY_COLUMN.DEFAULT]){
                    el.defaultValue=columnDefination[key][ENTITY_COLUMN.DEFAULT]
                //target[key][ENTITY_COLUMN.DEFAULT]=columnDefination[key][ENTITY_COLUMN.DEFAULT];
                }

                if(columnDefination[key][ENTITY_COLUMN.TYPE]==REF_TYPE.HIDDEN){
                    let inpEle=document.createElement("input")
                    inpEle.setAttribute("type","hidden");
                    el.bindRef(inpEle);
                }
        }
        else if(columnDefination[key][ENTITY_COLUMN.TYPE]==REF_TYPE.NON_INPUT){
         el=new EleRef();
        }
        if(el){
        target.prototype[key]=el;
      }
    }
      target.prototype[ENTITY.DEFINATION]=columnDefination;
      columnDefination={};
    //columnDefination={};
}




